unit MIRA_Config;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.StdCtrls, Vcl.ComCtrls, NumEdits;

type
  TConfigDialog = class(TForm)
    OKButton: TButton;
    CancelButton: TButton;
    OptionPage: TPageControl;
    SyncTab: TTabSheet;
    CPUUtilizeLbl: TLabel;
    CPUUtilizeEdt: TUpDownEdit;
    HDDUtilizeLbl: TLabel;
    HDDUtilizeEdt: TUpDownEdit;
    ScanIntervalLbl: TLabel;
    ScanIntervalEdt: TUpDownEdit;
    ScanScheduleLbl: TLabel;
    ScanDateTimeLbl: TLabel;
    ScanScheduleBtn: TButton;
    LogTab: TTabSheet;
    SaveLogChk: TCheckBox;
    LogLinageLbl: TLabel;
    LogLinageEdt: TUpDownEdit;
    ReportGrp: TGroupBox;
    ReportCopyChk: TCheckBox;
    ReportRemoveChk: TCheckBox;
    ReportDetectChk: TCheckBox;
    ReportAppointChk: TCheckBox;
    ReportSuccessChk: TCheckBox;
    ReportFailChk: TCheckBox;
    ReportBreakChk: TCheckBox;
    ShellexTab: TTabSheet;
    IntegrateShellChk: TCheckBox;
    WarningLbl: TLabel;
    procedure FormShow(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure EdtVerify(Sender: TObject; var AText: string; var APosition: Integer;
      Relation: TNumericallyRelationship);
    procedure ScanScheduleBtnClick(Sender: TObject);
  private
    { Private 錾 }
    procedure UpdateOKButton;
  public
    { Public 錾 }
  end;

var
  ConfigDialog: TConfigDialog;

implementation

{$R *.dfm}

uses
  MIRA_Main, MIRA_Schedule;

resourcestring
  SCPUUtilize = 'gp';
  SHDDUtilize = 'ؗ';
  SScanInterval = 'C^[o';
  SLogLinage = 's';
  SNonNumber = '%ssł';

procedure TConfigDialog.UpdateOKButton;
begin
  if CPUUtilizeEdt.Relation = nrNonNumber then
    WarningLbl.Caption := Format(SNonNumber, [SCPUUtilize])
  else if HDDUtilizeEdt.Relation = nrNonNumber then
    WarningLbl.Caption := Format(SNonNumber, [SHDDUtilize])
  else if ScanIntervalEdt.Relation = nrNonNumber then
    WarningLbl.Caption := Format(SNonNumber, [SScanInterval])
  else if LogLinageEdt.Relation = nrNonNumber then
    WarningLbl.Caption := Format(SNonNumber, [SLogLinage])
  else
    WarningLbl.Caption := '';

  OKButton.Enabled := WarningLbl.Caption = '';
end;

procedure TConfigDialog.FormShow(Sender: TObject);
begin
  with MainForm do
  begin
    //Sync
    CPUUtilizeEdt.Value := CPUUtilize;
    HDDUtilizeEdt.Value := HDDUtilize;
    ScanIntervalEdt.Value := ScanInterval;
    ScanDateTimeLbl.Caption := DateTimeToStr(ScanTime);
    //Log
    SaveLogChk.Checked := SaveLog;
    LogLinageEdt.Value := LogLinage;
    ReportCopyChk.Checked := omCopy in ReportMessages;
    ReportRemoveChk.Checked := omRemove in ReportMessages;
    ReportDetectChk.Checked := omDetect in ReportMessages;
    ReportAppointChk.Checked := omAppoint in ReportMessages;
    ReportSuccessChk.Checked := orSuccess in ReportResults;
    ReportFailChk.Checked := orFail in ReportResults;
    ReportBreakChk.Checked := orBreak in ReportResults;
    //Shell
    IntegrateShellChk.Checked := IntegrateShell;
  end;
  UpdateOKButton;
end;

procedure TConfigDialog.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
var
  Msg: TSyncOpMessages;
  Ret: TSyncOpResults;
begin
  if ModalResult = mrOK then
    with MainForm do
    begin
      //Sync
      CPUUtilize := CPUUtilizeEdt.Value;
      HDDUtilize := HDDUtilizeEdt.Value;
      ScanInterval := ScanIntervalEdt.Value;
      ScanTime := StrToDateTime(ScanDateTimeLbl.Caption);
      //Log
      SaveLog := SaveLogChk.Checked;
      LogLinage := LogLinageEdt.Value;
      Msg := [];
      if ReportCopyChk.Checked then Include(Msg, omCopy);
      if ReportRemoveChk.Checked then Include(Msg, omRemove);
      if ReportDetectChk.Checked then Include(Msg, omDetect);
      if ReportAppointChk.Checked then Include(Msg, omAppoint);
      ReportMessages := Msg;
      Ret := [];
      if ReportSuccessChk.Checked then Include(Ret, orSuccess);
      if ReportFailChk.Checked then Include(Ret, orFail);
      if ReportBreakChk.Checked then Include(Ret, orBreak);
      ReportResults := Ret;
      //Shell
      IntegrateShell := IntegrateShellChk.Checked;
    end;
end;

procedure TConfigDialog.EdtVerify(Sender: TObject; var AText: string;
  var APosition: Integer; Relation: TNumericallyRelationship);
begin
  UpdateOKButton;
end;

procedure TConfigDialog.ScanScheduleBtnClick(Sender: TObject);
begin
  if ScheduleDialog.ShowModal = mrOk then
    ScanDateTimeLbl.Caption := DateTimeToStr(ScheduleDialog.ScanTimeEdt.DateTime);
end;

end.
