unit MIRA_Main;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.ExtCtrls, Vcl.DdeMan, System.ImageList, Vcl.ImgList,
  Vcl.Menus, ShellNotifyIcon, Vcl.ToolWin, Vcl.ComCtrls, Vcl.StdCtrls, Generics.Collections;

{ Performance Data Helper iKvȕ̂݁j }

type
  PDH_STATUS = DWORD; //HRESULT?
  PDH_HQUERY = THandle;
  PDH_HCOUNTER = THandle;

  _PDH_FMT_COUNTERVALUE = record
    CStatus: DWORD;
    case Longint of
      1: (longValue: LONG);
      2: (doubleValue: Double);
      3: (largeValue: LONGLONG);
      4: (AnsiStringValue: LPSTR);
      5: (WideStringValue: LPCWSTR);
  end;
  PDH_FMT_COUNTERVALUE = _PDH_FMT_COUNTERVALUE;

const
  PDH_FMT_LONG = $00000100;
  PDH_FMT_DOUBLE = $00000200;
  PDH_FMT_LARGE = $00000400;
  PDH_FMT_NOSCALE = $00001000;
  PDH_FMT_1000 = $00002000;
  PDH_FMT_NOCAP100 = $00008000;

function PdhOpenQuery(szDataSource: LPCWSTR; dwUserData: DWORD_PTR;
  var phQuery: PDH_HQUERY): PDH_STATUS; stdcall; external 'Pdh.dll' name 'PdhOpenQueryW';
function PdhAddCounter(hQuery: PDH_HQUERY; szFullCounterPath: LPCWSTR; dwUserData: DWORD_PTR;
  var phCounter: PDH_HCOUNTER): PDH_STATUS; stdcall; external 'Pdh.dll' name 'PdhAddCounterW';
function PdhCollectQueryData(hQuery: PDH_HQUERY): PDH_STATUS; stdcall;
  external 'Pdh.dll' name 'PdhCollectQueryData';
function PdhGetFormattedCounterValue(hCounter: PDH_HCOUNTER; dwFormat: DWORD; lpdwType: LPDWORD;
  var pValue: PDH_FMT_COUNTERVALUE): PDH_STATUS; stdcall;
  external 'Pdh.dll' name 'PdhGetFormattedCounterValue';
function PdhCloseQuery(hQuery: PDH_HQUERY): PDH_STATUS; stdcall;
  external 'Pdh.dll' name 'PdhCloseQuery';

type
  TListView = class(Vcl.ComCtrls.TListView)
  private
    function GetItems: TListItems;
    procedure SetItems(Value: TListItems);
  protected
    function CanChange(Item: TListItem; Change: Integer): Boolean; override;
  published
    property Items: TListItems read GetItems write SetItems;
  end;

  TWatchOption = (
    woUpdateDirToo, //fBNgXVB
    woToBitbucket   //폜ɃS~ɓB
  );
  TWatchOptions = set of TWatchOption;

  TSyncOpStruct = record
    Path: string;   //tH_B
    Func: Integer;  //TSHFileOpStruct.wFunc ƓB
    Index: Integer; //s ListItem.Index
  end;
  PSyncOpStruct = ^TSyncOpStruct;

  TResumeStruct = packed record
    Path: array[0..MAX_PATH] of Char;
    Func: Integer;
    Index: Integer;
  end;

  TSyncOpResult = (
    orSuccess,  //B
    orFail,     //sB
    orBreak     //fB
  );
  TSyncOpResults = set of TSyncOpResult;

  TSyncOpMessage = (
    omCopy,   //Rs[iobNAbvXgAjB
    omRemove, //폜B
    omDetect, //oB
    omAppoint //\B
  );
  TSyncOpMessages = set of TSyncOpMessage;

  TOperationList = class(TList<TSyncOpStruct>)
  public
    { Public 錾 }
    procedure Push(const Value: TSyncOpStruct);
    function Pop: TSyncOpStruct;
    procedure RemoveItems(const AIndex: Integer);
  end;

  TWatcher = class(TObject)
  strict private
    { Private 錾 }
    FListView: TListView;
    FIndex: Integer;
    FHandle: HWND;
    FRegistID: Cardinal;
    FTitle: string;
    FSource: string;
    FDest: string;
    FIncludes: string;
    FExcludes: string;
    FAttrib: Integer;
    FKeeping: Integer;
    FStoring: Integer;
    FOptions: TWatchOptions;
    FPath: string;
    function GetOwner: TListItem;
    function GetEnabled: Boolean;
    procedure SetEnabled(Value: Boolean);
    procedure SetTitle(Value: string);
    procedure SetSource(Value: string);
    procedure SetDest(Value: string);
    procedure SetIncludes(Value: string);
    procedure SetExcludes(Value: string);
    procedure SetAttrib(Value: Integer);
    procedure SetKeeping(Value: Integer);
    procedure SetStoring(Value: Integer);
    procedure SetOptions(Value: TWatchOptions);
  protected
    { Protected 錾 }
    procedure WndProc(var Message: TMessage);
    procedure Stop;
    procedure Start;
  public
    { Public 錾 }
    constructor Create(AOwner: TListItem);
    destructor Destroy; override;
    function FetchOeration: TSyncOpStruct;
    property Owner: TListItem read GetOwner;
    property Enabled: Boolean read GetEnabled write SetEnabled;
    property Title: string read FTitle write SetTitle;
    property Source: string read FSource write SetSource;
    property Dest: string read FDest write SetDest;
    property Includes: string read FIncludes write SetIncludes;
    property Excludes: string read FExcludes write SetExcludes;
    property Attrib: Integer read FAttrib write SetAttrib;
    property Keeping: Integer read FKeeping write SetKeeping;
    property Storing: Integer read FStoring write SetStoring;
    property Options: TWatchOptions read FOptions write SetOptions;
  end;

  TMainForm = class(TForm)
    Timer: TTimer;
    DdeRestorConv: TDdeServerConv;
    DdeBackupConv: TDdeServerConv;
    MenuImages: TImageList;
    MainMenu: TMainMenu;
    FileMnu: TMenuItem;
    FileExitMnu: TMenuItem;
    ItemMnu: TMenuItem;
    ItemAddMnu: TMenuItem;
    ItemDeleteMnu: TMenuItem;
    ItemModifyMnu: TMenuItem;
    WatchMnu: TMenuItem;
    WatchStartMnu: TMenuItem;
    WatchStopMnu: TMenuItem;
    WatchInvertAllMnu: TMenuItem;
    SyncMnu: TMenuItem;
    SyncRestorMnu: TMenuItem;
    SyncBackupMnu: TMenuItem;
    SyncExplorerMnu: TMenuItem;
    SyncCleanupMnu: TMenuItem;
    OptionMnu: TMenuItem;
    OptionScheduleMnu: TMenuItem;
    OptionConfigMnu: TMenuItem;
    TrayImages: TImageList;
    TrayMenu: TPopupMenu;
    TrayResizeMnu: TMenuItem;
    TrayN1Mnu: TMenuItem;
    TrayScheduleMnu: TMenuItem;
    TrayConfigMnu: TMenuItem;
    TrayN2Mnu: TMenuItem;
    TrayInvertAllMnu: TMenuItem;
    TrayN3Mnu: TMenuItem;
    TrayExitMnu: TMenuItem;
    TrayIcon: TShellNotifyIcon;
    MainToolBar: TToolBar;
    ItemAddBtn: TToolButton;
    ItemDeleteBtn: TToolButton;
    ItemModifyBtn: TToolButton;
    ToolN1Btn: TToolButton;
    WatchStartBtn: TToolButton;
    WatchStopBtn: TToolButton;
    WatchInvertAllBtn: TToolButton;
    ToolN2Btn: TToolButton;
    SyncRestorBtn: TToolButton;
    SyncBackupBtn: TToolButton;
    SyncExplorerBtn: TToolButton;
    WatchView: TListView;
    Splitter: TSplitter;
    ReportView: TMemo;
    StatusBar: TStatusBar;
    SyncCleanupBtn: TToolButton;
    procedure FormCreate(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure FormDestroy(Sender: TObject);
    procedure TimerTimer(Sender: TObject);
    procedure DdeRestorConvExecuteMacro(Sender: TObject; Msg: TStrings);
    procedure DdeBackupConvExecuteMacro(Sender: TObject; Msg: TStrings);
    procedure MainMenuChange(Sender: TObject; Source: TMenuItem; Rebuild: Boolean);
    procedure FileExitMnuClick(Sender: TObject);
    procedure ItemAddMnuClick(Sender: TObject);
    procedure ItemDeleteMnuClick(Sender: TObject);
    procedure ItemModifyMnuClick(Sender: TObject);
    procedure WatchStartMnuClick(Sender: TObject);
    procedure WatchStopMnuClick(Sender: TObject);
    procedure WatchInvertAllMnuClick(Sender: TObject);
    procedure SyncRestorMnuClick(Sender: TObject);
    procedure SyncBackupMnuClick(Sender: TObject);
    procedure SyncCleanupMnuClick(Sender: TObject);
    procedure SyncExplorerMnuClick(Sender: TObject);
    procedure OptionScheduleMnuClick(Sender: TObject);
    procedure OptionConfigMnuClick(Sender: TObject);
    procedure TrayResizeMnuClick(Sender: TObject);
    procedure TrayIconShowAttempted(Sender: TObject);
    procedure WatchViewChange(Sender: TObject; Item: TListItem; Change: TItemChange);
    procedure WatchViewKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure WatchViewDeletion(Sender: TObject; Item: TListItem);
  private
    { Private 錾 }
    FCPUUtilize,
    FHDDUtilize: Integer;
    FScanInterval: Cardinal;
    FScanTime: TDateTime;
    FSaveLog: Boolean;
    FLogLinage: Integer;
    FIntegrateShell: Boolean;
    FReportMessages: TSyncOpMessages;
    FReportResults: TSyncOpResults;
    FWatchedCount: Integer;
    FQuery: PDH_HQUERY;
    FCPUCounter,
    FHDDCounter: PDH_HCOUNTER;
    FCPUCount,
    FHDDCount: Integer;
    FSynchroList,
    FFailList: TOperationList;
    procedure SetScanTime(Value: TDateTime);
    function GetRestoring: Boolean;
    procedure SetRestoring(Value: Boolean);
    function GetBacking: Boolean;
    procedure SetBacking(Value: Boolean);
    function GetCleaning: Boolean;
    procedure SetCleaning(Value: Boolean);
    procedure ReadOption;
    procedure WriteOption;
    procedure UpdateWatchStatus;
    procedure UpdateWatchItems;
    function AddWatcher: TWatcher;
    procedure DelWatcher(AWatcher: TWatcher);
    procedure ReadWatches;
    procedure WriteWatches;
    procedure ReadResume;
    procedure WriteResume;
    procedure WriteLog;
    procedure WriteShellex;
    procedure MonitorStop;
    procedure MonitorStart;
    procedure MonitorTick;
    procedure AddReport(Operation: TSyncOpMessage; Code: TSyncOpResult;
      Source: string; Dest: string = '');
    function CopyOperation(Source, Dest: string; SourceRec: TSearchRec): TSyncOpResult;
    function RemoveOperation(Source, Dest: string; DestRec: TSearchRec;
      Keeping: Integer; Option: TWatchOptions): TSyncOpResult;
    procedure OperationCancel(AWatcher: TWatcher);
    procedure RestorFiles(SourceRec: TSyncOpStruct; Overwrite: Boolean);
    procedure BackupFiles(SourceRec: TSyncOpStruct; Delay: Boolean);
    procedure CleanupFiles(DestRec: TSyncOpStruct; Delay: Boolean);
    procedure SynchroFiles(SourceRec: TSyncOpStruct; Delay: Boolean);
    function GetFirstWatcher: TWatcher;
    function GetNextWatcher(StartWatcher: TWatcher): TWatcher;
  protected
    { Protected 錾 }
    procedure WMQueryEndSession(var Msg: TWMQueryEndSession); message WM_QUERYENDSESSION;
  public
    { Public 錾 }
    procedure ApplicationMinimize(Sender: TObject);
    property CPUUtilize: Integer read FCPUUtilize write FCPUUtilize;
    property HDDUtilize: Integer read FHDDUtilize write FHDDUtilize;
    property ScanInterval: Cardinal read FScanInterval write FScanInterval;
    property ScanTime: TDateTime read FScanTime write SetScanTime;
    property SaveLog: Boolean read FSaveLog write FSaveLog;
    property LogLinage: Integer read FLogLinage write FLogLinage;
    property IntegrateShell: Boolean read FIntegrateShell write FIntegrateShell;
    property ReportMessages: TSyncOpMessages read FReportMessages write FReportMessages;
    property ReportResults: TSyncOpResults read FReportResults write FReportResults;
    property Restoring: Boolean read GetRestoring write SetRestoring;
    property Backing: Boolean read GetBacking write SetBacking;
    property Cleaning: Boolean read GetCleaning write SetCleaning;
  end;

function ContainedPath(FileName, Path: string; Attrib: Integer): Boolean;

const
  //`̃G[R[h
  ERROR_UNIDENTIFIED_ERROR = 1287;
  ERROR_NO_MATCH = 1169;

var
  MainForm: TMainForm;

implementation

{$R *.dfm}

uses
  MIRA_Consts, MIRA_Filer, MIRA_Seting, MIRA_Schedule, MIRA_Cleanup, MIRA_Config,
  System.UITypes, Winapi.ShlObj, FileUtils, Winapi.CommCtrl, ShellTypes, ShellUtils,
  Winapi.ShellAPI, AppData, SysInfo, RegData, System.IOUtils, System.DateUtils;

resourcestring
  SNext = '';
  SWatch = 'Ď';
  SNotFound = '%s ܂';
  SReserve= '\';
  SExecuteAll = 'ׂĎs';
  SExecuteAllHint = 'ׂĂ̊Ďs܂';
  SStopAll = 'ׂĒ~';
  SStopAllHint = 'ׂĂ̊Ď~܂';

var
  ChangeNotifyMsg: Cardinal;

{ Routine }

function StrToAttrib(Value: string): Integer;
var
  i: Integer;
begin
  Result := 0;
  for i := 1 to Length(Value) do
    case Value[i] of
      'R': Inc(Result, faReadOnly);
      'H': Inc(Result, faHidden);
      'S': Inc(Result, faSysFile);
      'D': Inc(Result, faDirectory);
      'A': Inc(Result, faArchive);
    end;
end;

function AttribToStr(Value: Integer): string;
begin
  Result := '';
  if AttrInSet(faReadOnly, Value) then
    Result := Result + 'R';
  if AttrInSet(faHidden, Value) then
    Result := Result + 'H';
  if AttrInSet(faSysFile, Value) then
    Result := Result + 'S';
  if AttrInSet(faDirectory, Value) then
    Result := Result + 'D';
  if AttrInSet(faArchive, Value) then
    Result := Result + 'A';
end;

function StrToOptions(Value: string): TWatchOptions;
var
  i: Integer;
begin
  Result := [];
  for i := 1 to Length(Value) do
    case Value[i] of
      'D': Include(Result, woUpdateDirToo);
      'B': Include(Result, woToBitbucket);
    end;
end;

function OptionsToStr(Value: TWatchOptions): string;
begin
  Result := '';
  if woUpdateDirToo in Value then
    Result := Result + 'D';
  if woToBitbucket in Value then
    Result := Result + 'B';
end;

function AttachID(FileName: string; Rec: TSearchRec; Keeping: Integer): string;
var
  ID: string;
begin
  Result := FileName;
  if not AttrInSet(faDirectory, Rec.Attr) and (Keeping > 0) then
  begin
    DateTimeToString(ID, '.yyyymmdd_hhmmss', FileTimeToLocalDateTime(Rec.FindData.ftLastWriteTime));
    Result := Result + ID + ExtractFileExt(Result);
  end;
end;

function DetachID(FileName: string; Rec: TSearchRec; Keeping: Integer): string;
begin
  Result := FileName;
  if not AttrInSet(faDirectory, Rec.Attr) and (Keeping > 0) then
  begin
    Result := ChangeFileExt(Result, '');
    if '' <> ExtractFileExt(Result) then
      Result := ChangeFileExt(Result, '');
  end;
end;

function ContainedPath(FileName, Path: string; Attrib: Integer): Boolean;
begin
  FileName := UpperCase(FileName);
  Path := UpperCase(Path);
  if AttrInSet(faDirectory, Attrib) then
    Result := Pos(FileName, Path) = 1
  else
    Result := (FileName = Path) or (FileName = ExtractFileDir(Path));
end;

{ TListView C }

function TListView.GetItems: TListItems;
begin
  //\ƍXVۗBe[}̕ύXȂǂɑΉłȂ߁AIɍXVB
  HandleNeeded;

  Result := inherited Items;
end;

procedure TListView.SetItems(Value: TListItems);
begin
  HandleNeeded;

  inherited Items := Value;
end;

function TListView.CanChange(Item: TListItem; Change: Integer): Boolean;
begin
  //Windows ̖H
  //Item.ImageIndex ̕ύXʒm͂̂ LVN_ITEMCHANGING ݂̂ LVN_ITEMCHANGED ͓͂ȂB
  //ʁACanChange ͎IɌĂ΂邪 Change Ă΂Ȃ߁AύX\Ȃ玩͂ŌĂяoB
  Result := inherited CanChange(Item, Change);

  if (Change = LVIF_IMAGE) and Result then
    Self.Change(Item, Change);
end;

{ TOperationList }

procedure TOperationList.Push(const Value: TSyncOpStruct);
begin
  Insert(0, Value);
end;

function TOperationList.Pop: TSyncOpStruct;
begin
  Result := First;
  Delete(0);
end;

procedure TOperationList.RemoveItems(const AIndex: Integer);
var
  i: Integer;
  Buf: TSyncOpStruct;
begin
  for i := Count - 1 downto 0 do
  begin
    if Items[i].Index = AIndex then
      Delete(i)
    else if Items[i].Index > AIndex then
    begin
      Buf := Items[i];
      Dec(Buf.Index);
      Items[i] := Buf;
    end;
  end;
end;

{ TWatcher }

function TWatcher.GetOwner: TListItem;
begin
  Result := FListView.Items.Item[FIndex];
end;

function TWatcher.GetEnabled: Boolean;
begin
  Result := FRegistID > 0;
end;

procedure TWatcher.SetEnabled(Value: Boolean);
begin
  if Value = Enabled then Exit;

  if Value then
  begin
    Start;
    Owner.ImageIndex := 3;
  end
  else
  begin
    Stop;
    Owner.ImageIndex := 5;
  end;
end;

procedure TWatcher.SetTitle(Value: string);
begin
  FTitle := Value;
  Owner.Caption := FTitle;
end;

procedure TWatcher.SetSource(Value: string);
begin
  FSource := Value;
  Owner.SubItems.Strings[0] := FSource;
end;

procedure TWatcher.SetDest(Value: string);
begin
  FDest := Value;
  Owner.SubItems.Strings[1] := FDest;
end;

procedure TWatcher.SetIncludes(Value: string);
begin
  FIncludes := Value;
  Owner.SubItems.Strings[2] := FIncludes;
end;

procedure TWatcher.SetExcludes(Value: string);
begin
  FExcludes := Value;
  Owner.SubItems.Strings[3] := FExcludes;
end;

procedure TWatcher.SetAttrib(Value: Integer);
begin
  FAttrib := Value;
  Owner.SubItems.Strings[4] := AttribToStr(FAttrib);
end;

procedure TWatcher.SetKeeping(Value: Integer);
begin
  FKeeping := Value;
  Owner.SubItems.Strings[5] := IntToStr(FKeeping);
end;

procedure TWatcher.SetStoring(Value: Integer);
begin
  FStoring := Value;
  Owner.SubItems.Strings[6] := IntToStr(FStoring);
end;
procedure TWatcher.SetOptions(Value: TWatchOptions);
begin
  FOptions := Value;
  Owner.SubItems.Strings[7] := OptionsToStr(FOptions);
end;

procedure TWatcher.WndProc(var Message: TMessage);
var
  Lock: THandle;
  PIDLs: PAbsoluteIDs;
  Event: Integer;
begin
  if Message.Msg = ChangeNotifyMsg then
  begin
    Lock := LockChangeNotify(Message.WParam, Message.LParam, PIDLs, Event);
    try
      if Lock <> 0 then
      begin
        case Event of
          SHCNE_MKDIR,
          SHCNE_CREATE:
            FPath := GetParseName(DesktopShellFolder, PIDLs^.Item1);
          SHCNE_RENAMEFOLDER,
          SHCNE_RENAMEITEM:
            FPath := GetParseName(DesktopShellFolder, PIDLs^.Item2);
          SHCNE_UPDATEDIR:
          begin
            if woUpdateDirToo in Options then
              FPath := GetParseName(DesktopShellFolder, PIDLs^.Item1)
            else
              FPath := '';
          end;
          SHCNE_UPDATEITEM:
            FPath := GetParseName(DesktopShellFolder, PIDLs^.Item1);
        else
          FPath := '';
        end;
        if FPath <> '' then
          Owner.ImageIndex := 4;
      end;
    finally
      UnlockChangeNotify(Lock);
    end;
  end
  else
    Message.Result := DefWindowProc(FHandle, Message.Msg, Message.WParam, Message.LParam);
end;

procedure TWatcher.Stop;
begin
  if Enabled then
  begin
    SHChangeNotifyDeregister(FRegistID);
    FRegistID := 0;
  end;
end;

procedure TWatcher.Start;
const
  SHCNRF_ShellSources = SHCNRF_InterruptLevel or SHCNRF_ShellLevel or SHCNRF_NewDelivery;
  SHCNE_FOLDEREVENTS = SHCNE_MKDIR {or SHCNE_RMDIR} or SHCNE_RENAMEFOLDER;
  SHCNE_ITEMEVENTS = SHCNE_CREATE {or SHCNE_DELETE} or SHCNE_RENAMEITEM;
var
  Sources: Integer;
  Events: Integer;
  Entry: TSHChangeNotifyEntry;
begin
  Stop;

  Sources := SHCNRF_ShellSources;
  Events := SHCNE_FOLDEREVENTS or SHCNE_ITEMEVENTS or SHCNE_UPDATEITEM;
  Entry.pidl := ParseDisplayName(DesktopShellFolder, Source);
  Entry.fRecursive := AttrInSet(faDirectory, Attrib);
  if Entry.fRecursive then
    Sources := Sources + SHCNRF_RecursiveInterrupt;
  FRegistID := SHChangeNotifyRegister(FHandle, Sources, Events, ChangeNotifyMsg, 1, Entry);
  if FRegistID = 0 then
    raise Exception.Create('FAIL: Register Notify');
end;

constructor TWatcher.Create(AOwner: TListItem);
begin
  inherited Create;

  FListView := AOwner.ListView as TListView;
  FIndex := AOwner.Index;
  Owner.ImageIndex := 5;
  while Owner.SubItems.Count <= 7 do
   Owner.SubItems.Add('');

  FHandle := AllocateHWnd(WndProc);
  if FHandle = 0 then
    raise Exception.Create('FAIL: Allocate Window');
  FRegistID := 0;
  FTitle := '';
  FSource := '';
  FDest := '';
  FIncludes := '';
  FExcludes := '';
  FAttrib := 0;
  FKeeping := 7;
  FStoring := 0;
  FOptions := [];
  FPath := '';
end;

destructor TWatcher.Destroy;
begin
  Stop;
  DeallocateHWnd(FHandle);

  inherited Destroy;
end;

function TWatcher.FetchOeration: TSyncOpStruct;
begin
  with Result do
  begin
    Path := FPath;
    Func := FO_COPY;
    Index := Owner.Index;
  end;
  Owner.ImageIndex := 3;
end;

{ TMainForm }

procedure TMainForm.SetScanTime(Value: TDateTime);
begin
  if Value <> FScanTime then
  begin
    FScanTime := Value;
    StatusBar.Panels.Items[2].Text := Format('%s: %s', [SNext, FormatDateTime('mm/dd hh:nn', FScanTime)]);
  end;
end;

function TMainForm.GetRestoring: Boolean;
begin
  Result := SyncRestorMnu.ImageIndex = 11;
end;

procedure TMainForm.SetRestoring(Value: Boolean);
begin
  if Value then
    SyncRestorMnu.ImageIndex := 11
  else
    SyncRestorMnu.ImageIndex := 8;
end;

function TMainForm.GetBacking: Boolean;
begin
  Result := SyncBackupMnu.ImageIndex = 11;
end;

procedure TMainForm.SetBacking(Value: Boolean);
begin
  if Value then
    SyncBackupMnu.ImageIndex := 11
  else
    SyncBackupMnu.ImageIndex := 9;
end;

function TMainForm.GetCleaning: Boolean;
begin
  Result := SyncCleanupMnu.ImageIndex = 11;
end;

procedure TMainForm.SetCleaning(Value: Boolean);
begin
  if Value then
    SyncCleanupMnu.ImageIndex := 11
  else
    SyncCleanupMnu.ImageIndex := 10;
end;

procedure TMainForm.ReadOption;
var
  IniFile: TAppIniFile;
  Msg: TSyncOpMessages;
  MsgBuf: Byte absolute Msg;
  Ret: TSyncOpResults;
  RetBuf: Byte absolute Ret;
begin
  IniFile := TAppIniFile.Create(AppDataName('ShaggyDog\Mira\Mira.ini'));
  try
    //Synchro
    CPUUtilize := IniFile.ReadInteger('Synchro', 'CPUUtilize', 50);
    HDDUtilize := IniFile.ReadInteger('Synchro', 'HDDUtilize', 50);
    ScanInterval := IniFile.ReadInteger('Synchro', 'ScanInterval', 720);
    ScanTime := IniFile.ReadDateTime('Synchro', 'ScanTime', Now);
    //Log
    SaveLog := IniFile.ReadBool('Log', 'SaveLog', False);
    LogLinage := IniFile.ReadInteger('Log', 'LogLinage', 256);
    MsgBuf := IniFile.ReadInteger('Log', 'ReportMessages', 3);  //[omCopy, omRemove]
    FReportMessages := Msg;
    RetBuf := IniFile.ReadInteger('Log', 'ReportResults', 3); //[orSuccess, orFail]
    ReportResults := Ret;
    //Shell
    IntegrateShell := IniFile.ReadBool('Shell', 'IntegrateShell', True);
  finally
    IniFile.Free;
  end;
end;

procedure TMainForm.WriteOption;
var
  IniFile: TAppIniFile;
  Msg: TSyncOpMessages;
  MsgBuf: Byte absolute Msg;
  Ret: TSyncOpResults;
  RetBuf: Byte absolute Ret;
begin
  IniFile := TAppIniFile.Create(AppDataName('ShaggyDog\Mira\Mira.ini'));
  try
    //Synchro
    IniFile.WriteInteger('Synchro', 'CPUUtilize', CPUUtilize);
    IniFile.WriteInteger('Synchro', 'HDDUtilize', HDDUtilize);
    IniFile.WriteInteger('Synchro', 'ScanInterval', ScanInterval);
    IniFile.WriteDateTime('Synchro', 'ScanTime', ScanTime);
    //Log
    IniFile.WriteBool('Log', 'SaveLog', SaveLog);
    IniFile.WriteInteger('Log', 'LogLinage', LogLinage);
    Msg := FReportMessages;
    IniFile.WriteInteger('Log', 'ReportMessages', MsgBuf);
    Ret := FReportResults;
    IniFile.WriteInteger('Log', 'ReportResults', RetBuf);
    //Shell
    IniFile.WriteBool('Shell', 'IntegrateShell', IntegrateShell);
  finally
    IniFile.Free;
  end;
end;

procedure TMainForm.UpdateWatchStatus;
begin
  StatusBar.Panels[0].Text := Format(' %s: %3d/%3d', [SWatch, FWatchedCount, WatchView.Items.Count]);
  TrayIcon.Hint := Format('Mira' + #13 + '%d/%d %s', [FWatchedCount, WatchView.Items.Count, SWatch]);
end;

procedure TMainForm.UpdateWatchItems;
var
  Selectable: Boolean;
begin
  Selectable := Assigned(WatchView.ItemFocused);

  ItemDeleteMnu.Enabled := Selectable;
  ItemModifyMnu.Enabled := Selectable;

  WatchStartMnu.Enabled := Selectable;
  WatchStopMnu.Enabled := Selectable;

  if Selectable then
  begin
    SyncRestorMnu.Enabled := not Backing;
    SyncBackupMnu.Enabled := not Restoring;
    SyncCleanupMnu.Enabled := not Cleaning;
  end
  else
  begin
    SyncRestorMnu.Enabled := False;
    SyncBackupMnu.Enabled := False;
    SyncCleanupMnu.Enabled := False;
  end;
  SyncExplorerMnu.Enabled := Selectable;

  ItemDeleteBtn.Enabled := ItemDeleteMnu.Enabled;
  ItemModifyBtn.Enabled := ItemModifyMnu.Enabled;

  WatchStartBtn.Enabled := WatchStartMnu.Enabled;
  WatchStopBtn.Enabled := WatchStopMnu.Enabled;

  SyncRestorBtn.Enabled := SyncRestorMnu.Enabled;
  SyncBackupBtn.Enabled := SyncBackupMnu.Enabled;
  SyncCleanupBtn.Enabled := SyncCleanupMnu.Enabled;
  SyncExplorerBtn.Enabled := SyncExplorerMnu.Enabled;
end;

function TMainForm.AddWatcher: TWatcher;
var
  NewItem: TListItem;
begin
  NewItem := WatchView.Items.Add;
  NewItem.Data := TWatcher.Create(NewItem);
  UpdateWatchStatus;

  Result := TWatcher(NewItem.Data);
end;

procedure TMainForm.DelWatcher(AWatcher: TWatcher);
begin
  AWatcher.Enabled := False;
  AWatcher.Owner.Delete;
  UpdateWatchStatus;
end;

procedure TMainForm.ReadWatches;
var
  IniFile: TAppIniFile;
  Sections: TStrings;
  Section: string;
  NewWatcher: TWatcher;
begin
  IniFile := TAppIniFile.Create(AppDataName('ShaggyDog\Mira\Watches.ini'));
  try
    WatchView.Items.Clear;
    Sections := TStringList.Create;
    try
      IniFile.ReadSections(Sections);
      for Section in Sections do
      begin
        NewWatcher := AddWatcher;
        with NewWatcher do
        begin
          Title := Section;
          Source := IniFile.ReadString(Section, 'Source', '');
          Dest := IniFile.ReadString(Section, 'Dest', '');
          Includes := IniFile.ReadString(Section, 'Include', '');
          Excludes := IniFile.ReadString(Section, 'Exclude', '');
          Attrib := StrToAttrib(IniFile.ReadString(Section, 'Attribute', ''));
          Keeping := IniFile.ReadInteger(Section, 'Keeping', 0);
          Storing := IniFile.ReadInteger(Section, 'Storing', 0);
          Options := StrToOptions(IniFile.ReadString(Section, 'Option', ''));
        end;
      end;
    finally
      Sections.Free;
    end;
    UpdateWatchItems;
  finally
    IniFile.Free;
  end;
  FWatchedCount := 0;
end;

procedure TMainForm.WriteWatches;
var
  IniFile: TAppIniFile;
  Item: TListItem;
begin
  IniFile := TAppIniFile.Create(AppDataName('ShaggyDog\Mira\Watches.ini'));
  try
    IniFile.Clear;
    for Item in WatchView.Items do
      with TWatcher(Item.Data) do
      begin
        IniFile.WriteString(Title, 'Source', Source);
        IniFile.WriteString(Title, 'Dest', Dest);
        IniFile.WriteString(Title, 'Include', Includes);
        IniFile.WriteString(Title, 'Exclude', Excludes);
        IniFile.WriteString(Title, 'Attribute', AttribToStr(Attrib));
        IniFile.WriteInteger(Title, 'Keeping', Keeping);
        IniFile.WriteInteger(Title, 'Storing', Storing);
        IniFile.WriteString(Title, 'Option', OptionsToStr(Options));
      end;
  finally
    IniFile.Free;
  end;
end;

procedure TMainForm.ReadResume;
var
  ResumeFile: string;
  Stream: TFileStream;
  Buf: TResumeStruct;
  SyncOp: TSyncOpStruct;
begin
  ResumeFile := AppDataName('ShaggyDog\Mira\Resume.dat');
  if FileExists(ResumeFile) then
  begin
    Stream := TFileStream.Create(ResumeFile, fmOpenRead);
    try
      while 0 <> Stream.Read(Buf, SizeOf(Buf)) do
      begin
        SyncOp.Path := string(Buf.Path);
        SyncOp.Func := Buf.Func;
        SyncOp.Index := Buf.Index;
        FSynchroList.Add(SyncOp);
      end;
    finally
      Stream.Free;
    end;
    DeleteFile(ResumeFile);
  end;
end;

procedure TMainForm.WriteResume;
var
  Stream: TFileStream;
  SyncOp: TSyncOpStruct;
  Buf: TResumeStruct;
  i: Integer;
begin
  if (FSynchroList.Count > 0) or (FFailList.Count > 0) then
  begin
    if FFailList.Count > 0 then
      FSynchroList.AddRange(FFailList);

    Stream := TFileStream.Create(AppDataName('ShaggyDog\Mira\Resume.dat'), fmCreate);
    try
      for i := 0 to FSynchroList.Count - 1 do
      begin
        SyncOp := FSynchroList.Items[i];
        StrCopy(Buf.Path, PChar(SyncOp.Path));
        Buf.Func := SyncOp.Func;
        Buf.Index := SyncOp.Index;
        Stream.Write(Buf, SizeOf(Buf));
      end;
    finally
      Stream.Free;
    end;
  end;
end;

procedure TMainForm.WriteLog;
var
  Report: TStrings;
  LogFile: string;
begin
  Report := TStringList.Create;
  try
    LogFile := AppDataName('ShaggyDog\Mira\Watches.log');
    if FileExists(LogFile) then
      Report.LoadFromFile(LogFile);
    Report.AddStrings(ReportView.Lines);
    Report.BeginUpdate;
    try
      while Report.Count > LogLinage do
        Report.Delete(0);
    finally
      Report.EndUpdate;
    end;
    Report.SaveToFile(LogFile);
  finally
    Report.Free;
  end;
end;

procedure TMainForm.WriteShellex;

  procedure RegistShellex(FileName: string; Entry: Boolean);
  var
    Parameters: string;
  begin
    if FileExists(FileName) then
    begin
      if Entry then
        Parameters := Format('/s %s', [AnsiQuotedStr(FileName, '"')])
      else
        Parameters := Format('/s /u %s', [AnsiQuotedStr(FileName, '"')]);
      ShellExecute(Handle, 'open', 'regsvr32', PChar(Parameters), '', SW_SHOWNORMAL);
    end
    else
      MessageDlg(Format(SNotFound, [FileName]), mtError, [mbOk], 0);
  end;

begin
  RegistShellex(ChangeFileExt(ParamStr(0), '.dll'), IntegrateShell);
  if IsWin64 then
    RegistShellex(ChangeFileExt(ParamStr(0), '.x64.dll'), IntegrateShell);
end;

procedure TMainForm.MonitorStop;
begin
  Timer.Enabled := False;
  if FQuery <> 0 then
    PdhCloseQuery(FQuery);
  StatusBar.Panels[3].Text := 'CPU: ---%';
  StatusBar.Panels[4].Text := 'DD: ---%';
end;

procedure TMainForm.MonitorStart;
var
  CounterPath: string;
begin
  MonitorStop;

  if PdhOpenQuery(nil, 0, FQuery) = ERROR_SUCCESS then
  begin
    CounterPath := '\Processor(_Total)\% Processor Time';
    if PdhAddCounter(FQuery, PChar(CounterPath), 0, FCPUCounter) = ERROR_SUCCESS then
    begin
      CounterPath := '\PhysicalDisk(_Total)\% Disk Time';
      if PdhAddCounter(FQuery, PChar(CounterPath), 0, FHDDCounter) = ERROR_SUCCESS then
      begin
        PdhCollectQueryData(FQuery);
        Timer.Enabled := True;
      end;
    end;
  end;
end;

procedure TMainForm.MonitorTick;
var
  Value: PDH_FMT_COUNTERVALUE;
begin
  if FQuery = 0 then Exit;

  if PdhCollectQueryData(FQuery) = ERROR_SUCCESS then
  begin
    if PdhGetFormattedCounterValue(FCPUCounter, PDH_FMT_DOUBLE, nil, Value) = ERROR_SUCCESS then
      FCPUCount := Round(Value.doubleValue)
    else
      FCPUCount := -1;

    if PdhGetFormattedCounterValue(FHDDCounter, PDH_FMT_DOUBLE, nil, Value) = ERROR_SUCCESS then
      FHDDCount := Round(Value.doubleValue)
    else
      FHDDCount := -1;

    StatusBar.Panels[3].Text := Format('CPU: %3d%%', [FCPUCount]);
    StatusBar.Panels[4].Text := Format('DD: %3d%%', [FHDDCount]);
  end
  else
  begin
    StatusBar.Panels[3].Text := 'CPU: ???%';
    StatusBar.Panels[4].Text := 'DD: ???%';
  end;
end;

procedure TMainForm.AddReport(Operation: TSyncOpMessage; Code: TSyncOpResult;
  Source: string; Dest: string = '');
var
  TimeStr, Msg, Report: string;
begin
  TimeStr := FormatDateTime('yyyy/mm/dd hh:nn:ss', Now);

  case Operation of
    omCopy: if omCopy in ReportMessages then Msg := 'CP';
    omRemove: if omRemove in ReportMessages then Msg := 'RM';
    omDetect: if omDetect in ReportMessages then Msg := 'DT';
    omAppoint: if omAppoint in ReportMessages then Msg := 'AP';
  else
    Exit;
  end;

  if Code in ReportResults then
  begin
    Report := Format('%s %s 0x%.4x %s', [TimeStr, Msg, GetLastError, Source]);
    if Dest <> '' then
      Report := Format('%s -> %s', [Report, Dest]);
    ReportView.Lines.Add(Report);
  end;
end;

function TMainForm.CopyOperation(Source, Dest: string; SourceRec: TSearchRec): TSyncOpResult;
var
  TimeStamp: TDateTime;
  ParentPath: string;
begin
  Result := orSuccess;
  SetLastError(ERROR_SUCCESS);

  TimeStamp := FileTimeToLocalDateTime(SourceRec.FindData.ftLastWriteTime);
  try
    if AttrInSet(faDirectory, SourceRec.Attr) then
    begin
      if TDirectory.Exists(Dest) then
      begin
        Result := orBreak;
        SetLastError(ERROR_ALREADY_EXISTS);
      end
      else
        TDirectory.CreateDirectory(Dest);
    end
    else
    begin
      if FileExists(Dest) and (TimeStamp = TFile.GetLastWriteTime(Dest)) then
      begin
        Result := orBreak;
        SetLastError(ERROR_ALREADY_EXISTS);
      end
      else
      begin
        ParentPath := ExtractFileDir(Dest);
        if not TDirectory.Exists(ParentPath) then
          TDirectory.CreateDirectory(ParentPath);

        TFile.Copy(Source, Dest, True);
        with SourceRec.FindData do
          SetTimeStamp(Dest, @ftCreationTime, @ftLastAccessTime, @ftLastWriteTime);
      end;
    end;
  except
    on E: Exception do
    begin
      Result := orFail;
      if E is EInOutError then
        SetLastError(EInOutError(E).ErrorCode)
      else
        SetLastError(ERROR_UNIDENTIFIED_ERROR);
    end;
  end;
  AddReport(omCopy, Result, Source, Dest);
end;

function TMainForm.RemoveOperation(Source, Dest: string; DestRec: TSearchRec;
  Keeping: Integer; Option: TWatchOptions): TSyncOpResult;
var
  TimeStamp,
  LapsedTime: TDateTime;
  FileOp: TSHFileOpStruct;
  OpResult: Integer;
begin
  if AttrInSet(faDirectory, DestRec.Attr) then
    TimeStamp := FileTimeToLocalDateTime(DestRec.FindData.ftCreationTime)
  else
    TimeStamp := FileTimeToLocalDateTime(DestRec.FindData.ftLastWriteTime);
  LapsedTime := Now - Keeping;

  if DirectoryExists(Source)
    or (FileExists(Source) and (TFile.GetLastWriteTime(Source) = TimeStamp))
    or (TimeStamp > LapsedTime) then
  begin
    Result := orBreak;
    SetLastError(ERROR_FILE_EXISTS);
  end
  else
  begin
    with FileOp do
    begin
      wnd := Handle;
      wFunc := FO_DELETE;
      pFrom := PChar(Dest + #0);
      pTo := '';
      fFlags := FOF_SILENT or FOF_NOCONFIRMATION or FOF_NOERRORUI;
      if woToBitbucket in Option then
        fFlags := fFlags or FOF_ALLOWUNDO;
      fAnyOperationsAborted := False;
      hNameMappings := nil;
      lpszProgressTitle := nil;
    end;
    OpResult := SHFileOperation(FileOp);
    if OpResult = 0 then
      Result := orSuccess
    else
      Result := orFail;
    SetLastError(OpResult);
  end;
  AddReport(omRemove, Result, Dest);
end;

procedure TMainForm.OperationCancel(AWatcher: TWatcher);
begin
  AWatcher.Enabled := False;

  FSynchroList.RemoveItems(AWatcher.Owner.Index);
  FFailList.RemoveItems(AWatcher.Owner.Index);
end;

procedure TMainForm.RestorFiles(SourceRec: TSyncOpStruct; Overwrite: Boolean);
type
  TSearchStruct = record
    SearchPath: string;
    SearchRec: TSearchRec;
  end;
var
  Watcher: TWatcher;
  Files: TDictionary<string, TSearchStruct>; //Dest, Source

  procedure EnumFiles(AFile: string);
  var
    AFileIsDir: Boolean;
    FindResult: Integer;
    Search: TSearchRec;
    Source: TSearchStruct;
    Dest: string;
    i: Integer;
    Time1, Time2: TDateTime;
  begin
    AFileIsDir := HasDirectory(AFile);
    if AFileIsDir then
      FindResult := FindFirst(TPath.Combine(AFile, '*'), faAnyFile, Search)
    else
      FindResult := FindFirst(AFile, faAnyFile, Search);
    try
      while FindResult = 0 do
      begin
        Application.ProcessMessages;
        if not Restoring then Exit;

        if not MatchesMasks(Search.Name, '.;..') then
        begin
          if AttrInSet(faDirectory, Search.Attr) then
            EnumFiles(TPath.Combine(AFile, Search.Name))
          else
          begin
            if AFileIsDir then
              Source.SearchPath := TPath.Combine(AFile, Search.Name)
            else
              Source.SearchPath := AFile;
            Source.SearchRec := Search;

            Dest := StringReplace(DetachID(Source.SearchPath, Search, Watcher.Keeping),
              Watcher.Dest, Watcher.Source, []);
            if not Overwrite then
            begin
              i := 0;
              repeat
                Inc(i);
                Dest := ChangeFileExt(Dest, Format('~%d', [i])) + ExtractFileExt(Dest);
              until not FileExists(Dest);
            end;

            if Files.ContainsKey(Dest) then
            begin
              Time1 := FileTimeToLocalDateTime(Files.Items[Dest].SearchRec.FindData.ftLastWriteTime);
              Time2 := FileTimeToLocalDateTime(Source.SearchRec.FindData.ftLastWriteTime);
              if Time1 < Time2 then
                Files.Items[Dest] := Source;
            end
            else
              Files.Add(Dest, Source);
          end;
        end;
        FindResult := FindNext(Search);
      end;
    finally
      FindClose(Search);
    end;
  end;

var
  Dest: string;
begin
  Watcher := TWatcher(WatchView.Items.Item[SourceRec.Index].Data);
  Files := TDictionary<string, TSearchStruct>.Create;
  try
    EnumFiles(SourceRec.Path);

    for Dest in Files.Keys do
    begin
      Application.ProcessMessages;
      if not Restoring then Break;

      with Files.Items[Dest] do
        CopyOperation(SearchPath, Dest, SearchRec);
    end;
  finally
    Files.Free;
  end;
end;

procedure TMainForm.BackupFiles(SourceRec: TSyncOpStruct; Delay: Boolean);
const
  AllAttrib = faReadOnly or faHidden or faSysFile or faDirectory or faArchive or faSymLink;
var
  Watcher: TWatcher;
  SrceParent, DestParent: string;
  SourceIsDir: Boolean;
  ExclAttr: Integer;
  FindResult: Integer;
  Search: TSearchRec;
  SrceName, DestName: string;
begin
  Watcher := TWatcher(WatchView.Items.Item[SourceRec.Index].Data);
  SrceParent := SourceRec.Path;
  DestParent := StringReplace(SrceParent, Watcher.Source, Watcher.Dest, []);
  SourceIsDir := HasDirectory(SrceParent);

  ExclAttr := AllAttrib - Watcher.Attrib;
  if AttrInSet(faDirectory, ExclAttr) then Dec(ExclAttr, faDirectory);  //ɏOB
  if AttrInSet(faArchive, ExclAttr) then Dec(ExclAttr, faArchive);      //B

  if SourceIsDir then
    FindResult := FindFirst(TPath.Combine(SrceParent, '*'), Watcher.Attrib, Search)
  else
    FindResult := FindFirst(SrceParent, Watcher.Attrib, Search);
  try
    while FindResult = 0 do
    begin
      Application.ProcessMessages;
      if Delay then
      begin
        if not Watcher.Enabled then Break;
      end
      else
      begin
        if not Backing then Break;
      end;

      if not MatchesMasks(Search.Name, '.;..') then
      begin
        if SourceIsDir then
        begin
          SrceName := TPath.Combine(SrceParent, Search.Name);
          DestName := AttachID(TPath.Combine(DestParent, Search.Name), Search, Watcher.Keeping);
        end
        else
        begin
          SrceName := SrceParent;
          DestName := AttachID(DestParent, Search, Watcher.Keeping);
        end;

        if MatchesCompoundMasks(Search.Name, Watcher.Includes, Watcher.Excludes) and
          not ContainsAttr(ExclAttr, SrceName, Watcher.Source) then
        begin
          if (CopyOperation(SrceName, DestName, Search) = orFail) and Delay then
            FFailList.Add(SourceRec);
          if AttrInSet(faDirectory, Search.Attr) then
          begin
            SourceRec.Path := SrceName;
            if Delay then
            begin
              FSynchroList.Push(SourceRec);
              AddReport(omAppoint, orSuccess, SourceRec.Path);
            end
            else
              BackupFiles(SourceRec, Delay);
          end;
        end
        else
        begin
          SetLastError(ERROR_NO_MATCH);
          AddReport(omCopy, orBreak, SrceName);
        end;
      end;
      FindResult := FindNext(Search);
    end;
  finally
    FindClose(Search);
  end;
end;

procedure TMainForm.CleanupFiles(DestRec: TSyncOpStruct; Delay: Boolean);
var
  Files: TObjectDictionary<string, TStringList>;  //Source, Dest's
  Watcher: TWatcher;
  SrceParent, DestParent: string;
  FindResult, i: Integer;
  Search: TSearchRec;
  SrceName, DestName: string;
begin
  Files := TObjectDictionary<string, TStringList>.Create([doOwnsValues]);
  try
    Watcher := TWatcher(WatchView.Items.Item[DestRec.Index].Data);
    DestParent := DestRec.Path;
    SrceParent := StringReplace(DestParent, Watcher.Dest, Watcher.Source, []);

    FindResult := FindFirst(TPath.Combine(DestParent, '*'), faAnyFile, Search);
    try
      while FindResult = 0 do
      begin
        Application.ProcessMessages;
        if Delay then
        begin
          if not Watcher.Enabled then Break;
        end
        else
        begin
          if not (Backing or Cleaning) then Break;
        end;

        if not MatchesMasks(Search.Name, '.;..') then
        begin
          SrceName := DetachID(TPath.Combine(SrceParent, Search.Name), Search, Watcher.Keeping);
          if not Files.ContainsKey(SrceName) then
          begin
            Files.Add(SrceName, TStringList.Create);
            Files.Items[SrceName].Sorted := True;
          end;
          DestName := TPath.Combine(DestParent, Search.Name);
          with Files.Items[SrceName] do
          begin
            Add(DestName);
            if Count > Watcher.Storing then
            begin
              i := Count - 1;
              if (RemoveOperation(SrceName, Strings[i], Search, Watcher.Keeping, Watcher.Options) = orFail)
                and Delay then
              begin
                FFailList.Add(DestRec);
              end;
              Delete(i);
            end;
          end;
          if AttrInSet(faDirectory, Search.Attr) then
          begin
            DestRec.Path := DestName;
            if Delay then
            begin
              FSynchroList.Push(DestRec);
              SetLastError(ERROR_SUCCESS);
              AddReport(omAppoint, orSuccess, DestRec.Path);
            end
            else
              CleanupFiles(DestRec, Delay);
          end;
        end;
        FindResult := FindNext(Search);
      end;
    finally
      FindClose(Search);
    end;

    i := 0;
    for SrceName in Files.Keys do
      Inc(i, Files.Items[SrceName].Count);
    if not DirectoryExists(SrceParent) and (Files.Count * Watcher.Storing >= i) then
    begin
      FindResult := FindFirst(DestParent, faAnyFile, Search);
      try
        if FindResult = 0 then
        begin
          if (RemoveOperation(SrceParent, DestParent, Search, Watcher.Keeping, Watcher.Options) = orFail)
            and Delay then
          begin
            FFailList.Add(DestRec);
          end;
        end;
      finally
        FindClose(Search);
      end;
    end;
  finally
    Files.Free;
  end;
end;

procedure TMainForm.SynchroFiles(SourceRec: TSyncOpStruct; Delay: Boolean);
var
  Watcher: TWatcher;
  SyncOp: TSyncOpStruct;
begin
  Watcher := TWatcher(WatchView.Items.Item[SourceRec.Index].Data);

  SyncOp.Path := StringReplace(SourceRec.Path, Watcher.Source, Watcher.Dest, []);
  SyncOp.Func := FO_DELETE;
  SyncOp.Index := SourceRec.Index;
  if Delay then
  begin
    FSynchroList.Add(SyncOp);
    SetLastError(ERROR_SUCCESS);
    AddReport(omAppoint, orSuccess, SyncOp.Path);
  end
  else
    CleanupFiles(SyncOp, Delay);

  SyncOp.Path := SourceRec.Path;
  SyncOp.Func := FO_COPY;
  SyncOp.Index := SourceRec.Index;
  if Delay then
  begin
    FSynchroList.Add(SyncOp);
    SetLastError(ERROR_SUCCESS);
    AddReport(omAppoint, orSuccess, SyncOp.Path);
  end
  else
    BackupFiles(SyncOp, Delay);
end;

function TMainForm.GetFirstWatcher: TWatcher;
var
  Item: TListItem;
begin
  Item := WatchView.Selected;
  if Assigned(Item) then
    Result := TWatcher(Item.Data)
  else
    Result := nil;
end;

function TMainForm.GetNextWatcher(StartWatcher: TWatcher): TWatcher;
var
  Item: TListItem;
begin
  if Assigned(StartWatcher) then
    Item := WatchView.GetNextItem(StartWatcher.Owner, sdAll, [isSelected])
  else
    Item := nil;
  if Assigned(Item) then
    Result := TWatcher(Item.Data)
  else
    Result := nil;
end;

procedure TMainForm.WMQueryEndSession(var Msg: TWMQueryEndSession);
begin
  Close;
end;

procedure TMainForm.ApplicationMinimize(Sender: TObject);
begin
  Hide;
  TrayIcon.IconIndex := -1;
  TrayIcon.Show;
end;

procedure TMainForm.FormCreate(Sender: TObject);
var
  Reg: TRegData;
begin
  ChangeNotifyMsg := RegisterWindowMessage('Mira SHChangeNotify Message');
  if ChangeNotifyMsg = 0 then
    raise Exception.Create(SysErrorMessage(GetLastError));

  Application.OnMinimize := ApplicationMinimize;
  FSynchroList := TOperationList.Create;
  FFailList := TOperationList.Create;

  ReadOption;
  ReadWatches;
  ReadResume;
  Reg := TRegData.Create;
  try
    if IntegrateShell xor Reg.KeyExists('Software\Classes\CLSID\' + STR_ShellExtension) then
      WriteShellex;
  finally
    Reg.Free;
  end;

  if FileExists(AppDataName('ShaggyDog\Mira\Watches.ini')) then
  begin
    Application.ShowMainForm := False;
    TrayIcon.Show;
  end;
end;

procedure TMainForm.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
var
  i: Integer;
begin
  MonitorStop;
  for i := 0 to WatchView.Items.Count - 1 do
    TWatcher(WatchView.Items.Item[i].Data).Stop;

  WriteResume;
  if SaveLog then
    WriteLog;
end;

procedure TMainForm.FormDestroy(Sender: TObject);
begin
  FSynchroList.Free;
  FFailList.Free;
end;

procedure TMainForm.TimerTimer(Sender: TObject);
var
  SyncOp: TSyncOpStruct;
  Item: TListItem;
  Watcher: TWatcher;
begin
  if FWatchedCount <= 0 then
    TrayIcon.IconIndex := 0
  else if FSynchroList.Count = 0 then
    TrayIcon.IconIndex := 1
  else
    TrayIcon.IconIndex := 2;
  StatusBar.Panels[1].Text := Format('%s: %4d', [SReserve, FSynchroList.Count]);

  MonitorTick;
  if (FCPUCount > CPUUtilize) or (FHDDCount > HDDUtilize) then Exit;

  if FSynchroList.Count > 0 then
  begin
    SyncOp := FSynchroList.Pop;
    if (FSynchroList.Count > 0) and (Pos(SyncOp.Path, FSynchroList.First.Path) = 1) then
    begin
      SetLastError(ERROR_IO_PENDING);
      AddReport(omAppoint, orBreak, SyncOp.Path)
    end
    else
      case SyncOp.Func of
        FO_COPY: BackupFiles(SyncOp, True);
        FO_DELETE: CleanupFiles(SyncOp, True);
      end;
  end
  else
  begin
    if FFailList.Count > 0 then
    begin
      FSynchroList.AddRange(FFailList);
      FFailList.Clear;
    end;

    if ScanTime <= Now then
    begin
      for Item in WatchView.Items do
      begin
        Watcher := TWatcher(Item.Data);
        if Watcher.Enabled then
        begin
          SyncOp.Path := Watcher.Source;
          SyncOp.Func := 0;
          SyncOp.Index := Item.Index;
          SynchroFiles(SyncOp, True);
        end;
      end;
      ScanTime := IncMinute(Now, ScanInterval);
      WriteOption;
    end;
  end;
end;

procedure TMainForm.DdeRestorConvExecuteMacro(Sender: TObject; Msg: TStrings);
var
  i: Integer;
begin
  Restoring := True;
  try
    FilerForm.Init(Msg);
    if mrOk = FilerForm.ShowModal then
      for i := 0 to FilerForm.FileView.ChkCount - 1 do
      begin
        Application.ProcessMessages;
        if not Restoring then Break;

        with FilerForm do
          RestorFiles(PSyncOpStruct(FileView.ChkItems[i].Data)^, OverwriteChk.Checked);
      end;
  finally
    Restoring := False;
  end;
end;

procedure TMainForm.DdeBackupConvExecuteMacro(Sender: TObject; Msg: TStrings);
var
  Item: TListItem;
  i: Integer;
  Watcher: TWatcher;
  SyncOp: TSyncOpStruct;
begin
  Backing := True;
  try
    for Item in WatchView.Items do
    begin
      Watcher := TWatcher(Item.Data);
      if ContainedPath(Watcher.Source, Msg.Strings[0], Watcher.Attrib) then
      begin
        for i := 0 to Msg.Count - 1 do
        begin
          SyncOp.Path := Msg.Strings[i];
          SyncOp.Func := FO_COPY;
          SyncOp.Index := Item.Index;
          BackupFiles(SyncOp, False);
        end;
      end;
    end;
  finally
    Backing := False;
  end;
end;

procedure TMainForm.MainMenuChange(Sender: TObject; Source: TMenuItem; Rebuild: Boolean);
begin
  if Assigned(WatchView.ItemFocused) then
  begin
    SyncRestorMnu.Enabled := not Backing;
    SyncBackupMnu.Enabled := not Restoring;
    SyncCleanupMnu.Enabled := not Cleaning;
  end
  else
  begin
    SyncRestorMnu.Enabled := False;
    SyncBackupMnu.Enabled := False;
    SyncCleanupMnu.Enabled := False;
  end;

  TrayInvertAllMnu.Caption := WatchInvertAllMnu.Caption;
  TrayInvertAllMnu.ImageIndex := WatchInvertAllMnu.ImageIndex;
  TrayInvertAllMnu.Hint := WatchInvertAllMnu.Hint;

  WatchInvertAllBtn.Caption := WatchInvertAllMnu.Caption;
  WatchInvertAllBtn.ImageIndex := WatchInvertAllMnu.ImageIndex;
  WatchInvertAllBtn.Hint := WatchInvertAllMnu.Hint;
  SyncRestorBtn.Enabled := SyncRestorMnu.Enabled;
  SyncRestorBtn.ImageIndex := SyncRestorMnu.ImageIndex;
  SyncBackupBtn.Enabled := SyncBackupMnu.Enabled;
  SyncBackupBtn.ImageIndex := SyncBackupMnu.ImageIndex;
  SyncCleanupBtn.Enabled := SyncCleanupMnu.Enabled;
  SyncCleanupBtn.ImageIndex := SyncCleanupMnu.ImageIndex;
end;

procedure TMainForm.FileExitMnuClick(Sender: TObject);
begin
  Close;
end;

procedure TMainForm.ItemAddMnuClick(Sender: TObject);
var
  NewWatcher: TWatcher;
begin
  NewWatcher := AddWatcher;
  NewWatcher.Owner.Focused := True;
  if SetingDialog.ShowModal = mrOk then
  begin
    WatchView.Change(NewWatcher.Owner, LVIF_IMAGE);
    WriteWatches;
  end
  else
    DelWatcher(NewWatcher);
end;

procedure TMainForm.ItemDeleteMnuClick(Sender: TObject);
var
  Watcher: TWatcher;
begin
  Watcher := GetFirstWatcher;
  while Assigned(Watcher) do
  begin
    OperationCancel(Watcher);
    DelWatcher(Watcher);

    Watcher := GetNextWatcher(Watcher);
  end;
  WriteWatches;
end;

procedure TMainForm.ItemModifyMnuClick(Sender: TObject);
var
  Watcher: TWatcher;
  Watched: Boolean;
begin
  Watcher := TWatcher(WatchView.ItemFocused.Data);
  Watched := Watcher.Enabled;
  Watcher.Enabled := False;
  try
    if SetingDialog.ShowModal = mrOk then
    begin
      OperationCancel(Watcher);
      WriteWatches;
    end;
  finally
    Watcher.Enabled := Watched;
  end;
end;

procedure TMainForm.WatchStartMnuClick(Sender: TObject);
var
  Watcher: TWatcher;
begin
  Watcher := GetFirstWatcher;
  while Assigned(Watcher) do
  begin
    Watcher.Enabled := True;

    Watcher := GetNextWatcher(Watcher);
  end;
end;

procedure TMainForm.WatchStopMnuClick(Sender: TObject);
var
  Watcher: TWatcher;
begin
  Watcher := GetFirstWatcher;
  while Assigned(Watcher) do
  begin
    Watcher.Enabled := False;

    Watcher := GetNextWatcher(Watcher);
  end;
end;

procedure TMainForm.WatchInvertAllMnuClick(Sender: TObject);
var
  Running: Boolean;
  Item: TListItem;
begin
  Running := FWatchedCount = 0;
  for Item in WatchView.Items do
    TWatcher(Item.Data).Enabled := Running;
end;

procedure TMainForm.SyncRestorMnuClick(Sender: TObject);
var
  Files: TStrings;
  Watcher: TWatcher;
  i: Integer;
begin
  if Restoring then
    Restoring := False
  else
  begin
    Files := TStringList.Create;
    try
      Watcher := GetFirstWatcher;
      while Assigned(Watcher) do
      begin
        Files.Add(Watcher.Source);
        Watcher := GetNextWatcher(Watcher);
      end;

      FilerForm.Init(Files);
      if FilerForm.ShowModal = mrOk then
      begin
        Restoring := True;
        try
          for i := 0 to FilerForm.FileView.ChkCount - 1 do
          begin
            Application.ProcessMessages;
            if not Restoring then Break;

            with FilerForm do
              RestorFiles(PSyncOpStruct(FileView.ChkItems[i].Data)^, OverwriteChk.Checked);
          end;
        finally
          Restoring := False;
        end;
      end;
    finally
      Files.Free;
    end;
  end;
end;

procedure TMainForm.SyncBackupMnuClick(Sender: TObject);
var
  Watcher: TWatcher;
  SyncOp: TSyncOpStruct;
begin
  Backing := not Backing;
  try
    if Backing then
    begin
      Watcher := GetFirstWatcher;
      while Assigned(Watcher) do
      begin
        Application.ProcessMessages;
        if not Backing then Break;

        SyncOp.Path := Watcher.Source;
        SyncOp.Func := FO_COPY;
        SyncOp.Index := Watcher.Owner.Index;
        BackupFiles(SyncOp, False);

        Watcher := GetNextWatcher(Watcher);
      end;
    end;
  finally
    Backing := False;
  end;
end;

procedure TMainForm.SyncCleanupMnuClick(Sender: TObject);
var
  Watcher: TWatcher;
  Kept, Stored: Integer;
  SyncOp: TSyncOpStruct;
begin
  if CleanupDialog.ShowModal = mrOk then
  begin
    Cleaning := not Cleaning;
    try
      if Cleaning then
      begin
        Watcher := GetFirstWatcher;
        while Assigned(Watcher) do
        begin
          Application.ProcessMessages;
          if not Cleaning then Break;

          Kept := Watcher.Keeping;
          Stored := Watcher.Storing;
          try
            Watcher.Keeping := CleanupDialog.KeepingEdt.Value;
            Watcher.Storing := CleanupDialog.StoringEdt.Value;

            SyncOp.Path := Watcher.Dest;
            SyncOp.Func := FO_DELETE;
            SyncOp.Index := Watcher.Owner.Index;
            CleanupFiles(SyncOp, False);
          finally
            Watcher.Keeping := Kept;
            Watcher.Storing := Stored;
          end;

          Watcher := GetNextWatcher(Watcher);
        end;
      end;
    finally
      Cleaning := False;
    end;
  end;
end;

procedure TMainForm.SyncExplorerMnuClick(Sender: TObject);
begin
  ShellExecute(0, nil, PChar(TWatcher(WatchView.ItemFocused.Data).Dest), '', '', SW_SHOWDEFAULT);
end;

procedure TMainForm.OptionScheduleMnuClick(Sender: TObject);
begin
  if ScheduleDialog.ShowModal = mrOk then
  begin
    ScanTime := ScheduleDialog.ScanTimeEdt.DateTime;
    WriteOption;
  end;
end;

procedure TMainForm.OptionConfigMnuClick(Sender: TObject);
begin
  if ConfigDialog.ShowModal = mrOk then
  begin
    WriteShellex;
    WriteOption;
  end;
end;

procedure TMainForm.TrayResizeMnuClick(Sender: TObject);
begin
  WindowState := wsNormal;  //Application.Restore ƕ\B
  TrayIcon.Hide;
  Show;
  SetForegroundWindow(Handle);
end;

procedure TMainForm.TrayIconShowAttempted(Sender: TObject);
begin
  if Assigned(TrayIcon.OnShowAttempted) then
  begin
    TrayIcon.OnShowAttempted := nil;
    Sleep(1000);  //ԂȂƁA\̃gCACRƌF₷Ȃ݂B
    MonitorStart;
    WatchInvertAllMnu.Click;

    //\݂B
    if not TrayIcon.Visible then
      TrayIcon.Show;
  end;
end;

procedure TMainForm.WatchViewChange(Sender: TObject; Item: TListItem; Change: TItemChange);
var
  SyncOp: TSyncOpStruct;
  ChkItem: TListItem;
begin
  case Change of
    ctImage:
      if Assigned(Item.Data) then
      begin
        if Item.ImageIndex = 4 then
        begin
          SyncOp := TWatcher(Item.Data).FetchOeration;
          FSynchroList.Push(SyncOp);
          SetLastError(ERROR_SUCCESS);
          AddReport(omDetect, orSuccess, SyncOp.Path);
        end
        else
        begin
          FWatchedCount := 0;
          for ChkItem in WatchView.Items do
            if TWatcher(ChkItem.Data).Enabled then Inc(FWatchedCount);
          UpdateWatchStatus;
          with WatchInvertAllMnu do
            if FWatchedCount = 0 then
            begin
              Hint := Format('%s|%s', [SExecuteAll, SExecuteAllHint]);
              Caption := Format('%s(&I)', [SExecuteAll]);
              ImageIndex := 6;
            end
            else
            begin
              Hint := Format('%s|%s', [SStopAll, SStopAllHint]);
              Caption := Format('%s(&I)', [SStopAll]);
              ImageIndex := 7;
            end;
        end;
      end;
    ctState: UpdateWatchItems;
  end;
end;

procedure TMainForm.WatchViewKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
begin
  if (Key = Word('A')) and (ssCtrl in Shift) then
    WatchView.SelectAll;
end;

procedure TMainForm.WatchViewDeletion(Sender: TObject; Item: TListItem);
begin
  if Assigned(Item) and Assigned(Item.Data) then
    TWatcher(Item.Data).Free;
end;

end.
